using System;
using System.Data;

using System.Data.SqlClient;
using System.Configuration;
using System.Web;
using System.Web.UI;
using Sql.DataAccessLayer;
using System.Collections.Generic;
using System.Text;

/// <summary>
/// Summary description for Favorites
/// </summary>
public class Favorites
{
    // Note: Favorite Important Terms

    // Type
    // 0: Video or Audio
    // 1: QA
    // 2: Albums and Galleries
 
    // this class handle user favorite videos.

    public Favorites()
	{
		
	}

    public static bool Add(string username, long VideoID,int mediatype, int type)
    {
        SqlHelper.ExecuteNonQuery(Config.ConnectionString,CommandType.Text,"Insert Into favorites(VideoID,username,date_added,type)values(@VideoID,@username,@date_added,@type)",new SqlParameter("@VideoID",VideoID),new SqlParameter("@username",username),new SqlParameter("@date_added",DateTime.Now), new SqlParameter("@type",type));
        Update_Fav_Stats(username, mediatype, type, 0);
        return true;
    }
    
     public static bool Delete(long VideoID,string username,int mediatype, int type)
    {
        SqlHelper.ExecuteNonQuery(Config.ConnectionString,CommandType.Text,"Delete FROM favorites WHERE VideoID=@videoid AND username=@username AND type=@type",new SqlParameter("@username",username),new SqlParameter("@videoid",VideoID),new SqlParameter("@type",type));
        Update_Fav_Stats(username, mediatype, type, 1);
        return true;
    }

   private static void Update_Fav_Stats(string username, int mediatype, int type, int action)
   {
       if (type != 2)
       {
           // changes happend
           string _field = "stat_favorites";
           if (mediatype == 1)
               _field = "stat_audiofavorites";
           else if (type == 1)
               _field = "stat_qafavorites";

           int count = Convert.ToInt32(members.Return_Value(username, _field));
           if (action == 0)
               count++;
           else
               count--;
           members.Update_Value(username, _field, count.ToString());
       }

   }
    
   public static bool Check_Favorites(string username, long VideoID,int type)
   {
       int result = Convert.ToInt32(SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT Count(username) FROM favorites WHERE username=@username AND VideoID=@videoid AND type=@type",new SqlParameter("@username",username),new SqlParameter("@videoid",VideoID),new SqlParameter("@type",type)));
       if(result >0)
           return true;
       else
           return false;
   }
}
