﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI.HtmlControls;

/// <summary>
/// This class is used to generate meta tags for different static and dynamic pages
/// </summary>
public class MetaTagsBLL
{
	public MetaTagsBLL()
	{
		//
		// TODO: Add constructor logic here
		//
	}

    #region Main
    // Meta Tags for Default Page
    public static void META_StaticPage(System.Web.UI.Page _pg, System.Web.UI.HtmlControls.HtmlHead _hd, string title, string description, string imageurl, string url)
    {      
        _pg.Title = title + " - " + Site_Settings.Page_Caption;
        PAGE_META(_hd, "", description);
        FB_META(_hd, title, description, imageurl, url);
    }
        
    #endregion
        

    private static void PAGE_META(HtmlHead _hd, string keywords, string description)
    {
        // Keyword
        //HtmlMeta hm = new HtmlMeta();
        //hm.Name = "keywords";
        //hm.Content = keywords.ToLower();
        //_hd.Controls.Add(hm);
        // Description
        HtmlMeta hm1 = new HtmlMeta();
        hm1.Name = "description";
        hm1.Content = description;
        _hd.Controls.Add(hm1);
    }

    private static void FB_META(HtmlHead _hd, string title, string description, string imageurl, string url)
    {
        if (Social_Settings.ShowFacebookMetaTags)
        {
            // og title
            HtmlMeta ogtitle = new HtmlMeta();
            ogtitle.Attributes.Add("property", "og:title");
            ogtitle.Attributes.Add("content", title);
            _hd.Controls.Add(ogtitle);
            // og description
            HtmlMeta ogdescription = new HtmlMeta();
            ogdescription.Attributes.Add("property", "og:description");
            ogdescription.Attributes.Add("content", description);
            _hd.Controls.Add(ogdescription);
            // og image
            if (imageurl != "")
            {
                HtmlMeta ogimage = new HtmlMeta();
                ogimage.Attributes.Add("property", "og:image");
                ogimage.Attributes.Add("content", imageurl);
                _hd.Controls.Add(ogimage);
            }
            // og type
            HtmlMeta ogtype = new HtmlMeta();
            ogtype.Attributes.Add("property", "og:type");
            ogtype.Attributes.Add("content", "article");
            _hd.Controls.Add(ogtype);

            // og url
            if (url != "")
            {
                HtmlMeta ogurl = new HtmlMeta();
                ogurl.Attributes.Add("property", "og:url");
                ogurl.Attributes.Add("content", url);
                _hd.Controls.Add(ogurl);
            }
            // og site name
            HtmlMeta ogsitename = new HtmlMeta();
            ogsitename.Attributes.Add("property", "og:site_name");
            ogsitename.Attributes.Add("content", Site_Settings.Page_Caption);
            _hd.Controls.Add(ogsitename);

            // fb app id
            HtmlMeta fbappid = new HtmlMeta();
            fbappid.Attributes.Add("property", "fb:app_id");
            fbappid.Attributes.Add("content", Social_Settings.FB_AppID);
            _hd.Controls.Add(fbappid);
        }
    }

    public static void FB_META_V2(System.Web.UI.Page _pg, System.Web.UI.HtmlControls.HtmlHead _hd, string title, string description, string imageurl, string videourl, string url)
    {
        // static page meta tags
        _pg.Title = title + " - " + Site_Settings.Page_Caption;
        PAGE_META(_hd, "", description);

        if (Social_Settings.ShowFacebookMetaTags)
        {
            // og type
            HtmlMeta ogtype = new HtmlMeta();
            ogtype.Attributes.Add("property", "og:type");
            ogtype.Attributes.Add("content", "movie");
            _hd.Controls.Add(ogtype);

            // og video height
            HtmlMeta ogvideoheight = new HtmlMeta();
            ogvideoheight.Attributes.Add("property", "og:video:height");
            ogvideoheight.Attributes.Add("content", "260");
            _hd.Controls.Add(ogvideoheight);

            // og video width
            HtmlMeta ogvideowidth = new HtmlMeta();
            ogvideowidth.Attributes.Add("property", "og:video:width");
            ogvideowidth.Attributes.Add("content", "420");
            _hd.Controls.Add(ogvideowidth);

            // og video type
            HtmlMeta ogvideotype = new HtmlMeta();
            ogvideotype.Attributes.Add("property", "og:video:type");
            ogvideotype.Attributes.Add("content", "application/x-shockwave-flash");
            _hd.Controls.Add(ogvideotype);

            // og title
            HtmlMeta ogtitle = new HtmlMeta();
            ogtitle.Attributes.Add("property", "og:title");
            ogtitle.Attributes.Add("content", title);
            _hd.Controls.Add(ogtitle);

            // og description
            HtmlMeta ogdescription = new HtmlMeta();
            ogdescription.Attributes.Add("property", "og:description");
            ogdescription.Attributes.Add("content", description);
            _hd.Controls.Add(ogdescription);
            // og image
            if (imageurl != "")
            {
                HtmlMeta ogimage = new HtmlMeta();
                ogimage.Attributes.Add("property", "og:image");
                ogimage.Attributes.Add("content", imageurl);
                _hd.Controls.Add(ogimage);
            }

            // og video
            if (videourl != "")
            {
                HtmlMeta ogvideo = new HtmlMeta();
                ogvideo.Attributes.Add("property", "og:video");
                ogvideo.Attributes.Add("content", videourl);
                _hd.Controls.Add(ogvideo);
            }

            // og url
            if (url != "")
            {
                HtmlMeta ogurl = new HtmlMeta();
                ogurl.Attributes.Add("property", "og:url");
                ogurl.Attributes.Add("content", url);
                _hd.Controls.Add(ogurl);
            }

            // og site name
            HtmlMeta ogsitename = new HtmlMeta();
            ogsitename.Attributes.Add("property", "og:site_name");
            ogsitename.Attributes.Add("content", Site_Settings.Page_Caption);
            _hd.Controls.Add(ogsitename);

            // fb app id
            HtmlMeta fbappid = new HtmlMeta();
            fbappid.Attributes.Add("property", "fb:app_id");
            fbappid.Attributes.Add("content", Social_Settings.FB_AppID);
            _hd.Controls.Add(fbappid);
        }
    }
}