﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Text;

/// <summary>
/// Summary description for VideoItem
/// </summary>
public class VideoItem
{
	public VideoItem()
	{
		//
		// TODO: Add constructor logic here
		//
	}

    #region MyRegion

    private int _boxwidth = 0; // complete width of box (0:100%)
    private int _width = 136; // width of thumb inside box
    private int _leftwidth = 40; // in % in case of showing thumb left and content on right
    private int _rightwidth = 59; // in % in case of showing thumb left and content on right
    private int _height = 0; // 0: default height of thumb inside box
    private int _space = 15; // space between two items

    private int _type = 0; // 0: video, 1: audio
    private bool _ishovereffect = false; // show hover effect on mouse move
    private bool _isaltcolor = false; // show background in alternative color
    private bool _breakline = false; // break current line
    private bool _showeditlink = false; // show edit link in case of editting content of photo
    private bool _isadmin = false; // admin mode
    private int _thumbpreviewoption = 0; // 0: thumb, 1: mid thumb, 2: original photo

    // Show Options
    private bool _showthumb = true; // display thumb
    private bool _thumbonly = false; // display photo thumb only without displaying any further data
    private int _titlelength = 35; // maximum allowed length of title
    private bool _showtitle = true; // show title of photo
    private bool _showdescription = false; // show description of photo
    private int _descriptionlength = 0; // 0: show complete description
    private bool _showtags = false; // show tags with each item
    private int _tagslength = 0; // 0: show all tags
    private bool _showcategories = false; // show categories
    private int _categorieslength = 0;
    private bool _showdate = true;
    private int _dateformat = 3; //  // 0:  21 May, 2011, 1: May 30th, 2011, 2: May 11 2011, 3: 2 days ago, 4: Today 10:54 PM
    private bool _showviews = true;
    private bool _showliked = false;
    private bool _showdisliked = false;
    private bool _showapproved = false;
    private bool _showdisabled = false;
    private bool _showadult = false;
    private bool _showfeatured = false;
    private bool _showcomments = false;
    private bool _showratingstar = false;
    private bool _showauthor = false;
    private bool _showdownloads = false;    
    // urls
    private string _editlinkurl = "";
    private string _previewurl = ""; // url of title or thumb preview, if empty default url will be used
    private string _authorurl = ""; // url of author of photo, if empty default url will be used.

    private int _contentlayout = 0; // 0: content on bottom of thumb, 1: content on left side of thumb

    // css styles
    private string _boxcssclass = "";
    private string _hovercssclass = "simplehover";
    private string _altcsslass = "simplehoveralt";
    private string _altlinkcssclass = "normal-text light";
    private string _boldlinkcssclass = "normal-text bold";
    private string _normallinkcssclass = "normal-text";
    private string _normaltextcssclass = "normal-text";
    private string _goodcssclass = "mini-text green bold";
    private string _badcssclass = "mini-text red bold";

    // captions
    private string _categorycaption = "Posted Under: ";
    private string _tagcaption = "Tags: ";
    private string _datecpation = "";
    private string _usercapption = "";

    public int BoxWidth
    {
        set { _boxwidth = value; }
        get { return _boxwidth; }
    }

    public int Width
    {
        set { _width = value; }
        get { return _width; }
    }

    public int LeftWidth
    {
        set { _leftwidth = value; }
        get { return _leftwidth; }
    }

    public int RightWidth
    {
        set { _rightwidth = value; }
        get { return _rightwidth; }
    }

    public int Height
    {
        set { _height = value; }
        get { return _height; }
    }

    public int BoxSpace
    {
        set { _space = value; }
        get { return _space; }
    }

    public int Type
    {
        set { _type = value; }
        get { return _type; }
    }

    public bool isHoverEffect
    {
        set { _ishovereffect = value; }
        get { return _ishovereffect; }
    }

    public bool isAltColor
    {
        set { _isaltcolor = value; }
        get { return _isaltcolor; }
    }

    public bool BreakLine
    {
        set { _breakline = value; }
        get { return _breakline; }
    }

    public bool ShowEditLink
    {
        set { _showeditlink = value; }
        get { return _showeditlink; }
    }

    public bool isAdmin
    {
        set { _isadmin = value; }
        get { return _isadmin; }
    }

    public int ThumbPreviewOption
    {
        set { _thumbpreviewoption = value; }
        get { return _thumbpreviewoption; }
    }

    public bool ShowThumb
    {
        set { _showthumb = value; }
        get { return _showthumb; }
    }

    public bool ThumbOnly
    {
        set { _thumbonly = value; }
        get { return _thumbonly; }
    }

    public int TitleLength
    {
        set { _titlelength = value; }
        get { return _titlelength; }
    }

    public bool ShowTitle
    {
        set { _showtitle = value; }
        get { return _showtitle; }
    }

    public bool ShowDescription
    {
        set { _showdescription = value; }
        get { return _showdescription; }
    }
    public int DescriptionLength
    {
        set { _descriptionlength = value; }
        get { return _descriptionlength; }
    }

    public bool ShowTags
    {
        set { _showtags = value; }
        get { return _showtags; }
    }

    public int TagsLength
    {
        set { _tagslength = value; }
        get { return _tagslength; }
    }
    public bool ShowCategories
    {
        set { _showcategories = value; }
        get { return _showcategories; }
    }

    public int CategoriesLength
    {
        set { _categorieslength = value; }
        get { return _categorieslength; }
    }
    public bool ShowDate
    {
        set { _showdate = value; }
        get { return _showdate; }
    }
    public int DateFormat
    {
        set { _dateformat = value; }
        get { return _dateformat; }
    }
    public bool ShowViews
    {
        set { _showviews = value; }
        get { return _showviews; }
    }

    public bool Showliked
    {
        set { _showliked = value; }
        get { return _showliked; }
    }

    public bool ShowDisliked
    {
        set { _showdisliked = value; }
        get { return _showdisliked; }
    }

    public bool ShowApproved
    {
        set { _showapproved = value; }
        get { return _showapproved; }
    }

    public bool ShowDisabled
    {
        set { _showdisabled = value; }
        get { return _showdisabled; }
    }

    public bool ShowFeatured
    {
        set { _showfeatured = value; }
        get { return _showfeatured; }
    }
    public bool ShowAdult
    {
        set { _showadult = value; }
        get { return _showadult; }
    }

    public bool ShowComments
    {
        set { _showcomments = value; }
        get { return _showcomments; }
    }

    public bool ShowRatingStar
    {
        set { _showratingstar = value; }
        get { return _showratingstar; }
    }

    public bool ShowAuthor
    {
        set { _showauthor = value; }
        get { return _showauthor; }
    }

    public bool ShowDownloads
    {
        set { _showdownloads = value; }
        get { return _showdownloads; }
    }

    public string EditLinkUrl
    {
        set { _editlinkurl = value; }
        get { return _editlinkurl; }
    }
    public string PreviewUrl
    {
        set { _previewurl = value; }
        get { return _previewurl; }
    }

    public string AuthorUrl
    {
        set { _authorurl = value; }
        get { return _authorurl; }
    }

    public int ContentLayout
    {
        set { _contentlayout = value; }
        get { return _contentlayout; }
    }

    public string BoxCssClass
    {
        set { _boxcssclass = value; }
        get { return _boxcssclass; }
    }

    public string HoverCssClass
    {
        set { _hovercssclass = value; }
        get { return _hovercssclass; }
    }

    public string AltCssClass
    {
        set { _altcsslass = value; }
        get { return _altcsslass; }
    }

    public string BoldLinkCssClass
    {
        set { _boldlinkcssclass = value; }
        get { return _boldlinkcssclass; }
    }
    public string AltLinkCssClass
    {
        set { _altlinkcssclass = value; }
        get { return _altlinkcssclass; }
    }
    public string NormalLinkCssClass
    {
        set { _normallinkcssclass = value; }
        get { return _normallinkcssclass; }
    }
    public string NormalTextCssClass
    {
        set { _normaltextcssclass = value; }
        get { return _normaltextcssclass; }
    }

    public string GoodCssClass
    {
        set { _goodcssclass = value; }
        get { return _goodcssclass; }
    }

    public string BadCssClass
    {
        set { _badcssclass = value; }
        get { return _badcssclass; }
    }
    public string TagCaption
    {
        set { _tagcaption = value; }
        get { return _tagcaption; }
    }

    public string CategoryCaption
    {
        set { _categorycaption = value; }
        get { return _categorycaption; }
    }

    public string DateCaption
    {
        set { _datecpation = value; }
        get { return _datecpation; }
    }

    public string UserCaption
    {
        set { _usercapption = value; }
        get { return _usercapption; }
    }
    #endregion

    public string Process(Video_Struct vd)
    {
        if (this.AuthorUrl == "")
            this.AuthorUrl = UrlConfig.Prepare_User_Profile_Url(vd.UserName, this.isAdmin);
        if (this.PreviewUrl == "")
        {
            if (this.Type == 1)
                this.PreviewUrl = UrlConfig.Prepare_Audio_Preview_Url(vd.VideoID, vd.Title, this.isAdmin);
            else
                this.PreviewUrl = UrlConfig.Prepare_Video_Preview_Url(vd.VideoID, vd.Title, this.isAdmin);
        }
        StringBuilder str = new StringBuilder();
        string _bxwidth = "100%";
        if(this.BoxWidth>0)
            _bxwidth = this.BoxWidth + "px;";
        string _cntwidth = "";
        if (this.BoxWidth == 0)
            _cntwidth = "99%";
        else
        {
            int containerwidth = this.BoxWidth;
            if (this.BoxSpace > 0)
                containerwidth = this.BoxWidth - this.BoxSpace;
            _cntwidth = containerwidth + "px";
        }
        str.Append("<div class=\"" + this.BoxCssClass + "\" style=\"float:left; width:" + _bxwidth + "\">\n");
        string container = "class=\"item_pad_2\"";
        if (this.isHoverEffect)
            container = "class=\"" + this.HoverCssClass + "\"";
        if (this.isAltColor)
            container = "class=\"" + this.AltCssClass + "\"";
        str.Append("<div " + container + " style=\"width:" + _cntwidth + "\">\n");
        if (this.ContentLayout == 0)
        {
            // Content on bottom of thumb
            str.Append(ProcessThumb(vd));
            str.Append("<div class=\"item_pad_2\">\n");
            str.Append(ProcessContent(vd));
            str.Append("</div>\n");
        }
        else
        {
            // Content on left side of thumb
            str.Append("<div class=\"row-fluid\">\n");
            str.Append("<div style=\"float:left; width:" + this.LeftWidth + "%;\">\n");
            str.Append(ProcessThumb(vd));
            str.Append("</div>\n");
            str.Append("<div style=\"float:right; width:" + this.RightWidth + "%;\">\n");
            str.Append(ProcessContent(vd));
            str.Append("</div></div>\n");
        }
        str.Append("</div>\n"); // close sub box
        str.Append("</div>\n"); // close main box
        if (this.BreakLine)
        {
            str.Append("<div class=\"clear\"></div>\n");
            this.BreakLine = false;
        }

        // reset url for next item
        this.AuthorUrl = "";
        this.PreviewUrl = "";
        return str.ToString();
    }

    private string ProcessThumb(Video_Struct vd)
    {
        StringBuilder str = new StringBuilder();
        if (this.ShowThumb)
        {            
            //str.Append("<div class=\"item\">");
            // thumb processing
            if (vd.isPublished == 0)
            {
                // unpublished video
                str.Append("<img src=\"" + Config.GetUrl("images/unpubvd.jpg") + "\" class=\"thumbnail\" title=\"media file is not published yet\" style=\"width:" + this.Width + "px; height:" + this.Height + "px;\" />\n");
            }
            else
            {
                // video thumb
                str.Append("<div class=\"vd\" style=\"width: " + this.Width + "px;\">");
                bool isaudio = false;
                if (this.Type == 1)
                    isaudio = true;
                str.Append(UGeneral.ProcessVideoThumb(this.Width, this.Height, this.PreviewUrl, vd, isaudio));
                // close media thumb section
                //str.Append("</div>"); // close thumb div
                // duration div
                // video item duration section
                str.Append("<div class=\"dur mini-text ui-corner-all\" style=\"bottom:5px; right:1px;\">");
                str.Append(vd.Duration);
                str.Append("</div>"); // close duration div
                str.Append("</div>"); // close vd div
            }
           
        }
        return str.ToString();
    }

    private string ProcessContent(Video_Struct vd)
    {
        StringBuilder str = new StringBuilder();
        // title or caption
        if (this.ShowTitle)
        {
            string _title = vd.Title;
            if (_title.Length > this.TitleLength && this.TitleLength > 0)
                _title = _title.Substring(0, this.TitleLength) + "..";
            if (_title != "")
            {
                string _title_url = "";
                if (vd.isPublished == 1)
                    _title_url = "<a href=\"" + this.PreviewUrl + "\" class=\"" + this.BoldLinkCssClass + "\" title=\"" + vd.Title + "\">" + _title + "</a>";
                else
                    _title_url = _title;
                str.Append(_title_url);
            }
        }
        // Added
        if (Config.isFeature_Date() && this.ShowDate)
        {
            str.Append("<br />");
            if (this.DateCaption != "")
                str.Append("<span class=\"" + this.AltLinkCssClass + "\">" + this.DateCaption + " </span>");
            str.Append("<span class=\"" + this.AltLinkCssClass + "\">" + UtilityBLL.Generate_Date(vd.Date_Added, this.DateFormat) + "</span>");
        }
        // Description
        if (this.ShowDescription && vd.Description != "")
        {
            str.Append("<br /><span class=\"" + this.NormalTextCssClass + "\">" + UGeneral.Prepare_Description(vd.Description, this.DescriptionLength) + "</span>");
        }
        // Categories
        if (this.ShowCategories && vd.Categories != "")
        {
            int cattype = 0;
            if (this.Type == 1)
                cattype = 7;
            str.Append("<br /><span class=\"" + this.AltLinkCssClass + "\">" + this.CategoryCaption + "</span>" + UGeneral.Prepare_Categories(vd.Categories, this.CategoriesLength, this.NormalLinkCssClass, cattype));
        }
        // Tags
        if (this.ShowTags && vd.Tags != "")
        {
            int tagtype = 0;
            if (this.Type == 1)
                tagtype = 4;
            str.Append("<br /><span class=\"" + this.AltLinkCssClass + "\">" + this.TagCaption + "</span>" + UGeneral.Prepare_Tags(vd.Tags, this.TagsLength, this.NormalLinkCssClass, tagtype));
        }

        // Views
        if (Config.isFeature_Views() && this.ShowViews)
        {
            string _views = "0";
            if (vd.Views > 0)
                _views = string.Format("{0:#,###}", vd.Views);

            if (this.ShowTitle || this.ShowDate)
                str.Append("<br />");
             str.Append("<span class=\"" + this.AltLinkCssClass + "\">" + _views + " " + Resources.vsk.views + "</span>");
        }

        // Downloads
        if (this.ShowDownloads)
        {
            string _downloads = "0";
            if (vd.Downloads > 0)
                _downloads = string.Format("{0:#,###}", vd.Downloads);
            str.Append("<br /><span class=\"" + this.AltLinkCssClass + "\">" + _downloads + " downloads</span>");
        }

        // liked , disliked
        if (this.Showliked && this.ShowDisliked)
        {
            string _liked = "0";
            if (vd.Liked > 0)
                _liked = string.Format("{0:#,###}", vd.Liked);
            string _disliked = "0";
            if (vd.Disliked > 0)
                _disliked = string.Format("{0:#,###}", vd.Disliked);

            str.Append("<br />Liked: <strong>" + _liked + "</strong>&nbsp;|&nbsp;Disliked: <strong>" + _disliked + "</strong>");
        }
        else if (this.Showliked)
        {
            string _liked = "0";
            if (vd.Liked > 0)
                _liked = string.Format("{0:#,###}", vd.Liked);

            str.Append("<br />Liked: <strong>" + _liked + "</strong>");
        }
        if (vd.isPublished == 0)
        {
            str.Append("<br /><span class=\"red bold\">Unpublished yet!</span>");
        }
        // approved, disabled
        if (this.ShowApproved && this.ShowDisabled)
        {
            string _approve = "<span class=\"" + this.GoodCssClass + "\">" + Resources.vsk.approved + "</span>\n";
            if (vd.isReviewed == 0)
                _approve = "<span class=\"" + this.BadCssClass + "\">Not approved</span>\n";

            string _disabled = "<span class=\"" + this.GoodCssClass + "\">" + Resources.vsk.enabled + "</span>\n";
            if (vd.isEnabled == 0)
                _disabled = "<span class=\"" + this.BadCssClass + "\">Disabled</span>\n";

            str.Append("<br />" + _approve + "&nbsp;|&nbsp;" + _disabled);
        }
        else if (this.ShowApproved)
        {
            string _approve = "<span class=\"" + this.GoodCssClass + "\">" + Resources.vsk.approved + "</span>\n";
            if (vd.isReviewed == 0)
                _approve = "<span class=\"" + this.BadCssClass + "\">Not approved</span>\n";
            str.Append("<br />" + _approve);
        }
        else if (this.ShowDisabled)
        {
            string _disabled = "<span class=\"" + this.GoodCssClass + "\">" + Resources.vsk.enabled + "</span>\n";
            if (vd.isEnabled == 0)
                _disabled = "<span class=\"" + this.BadCssClass + "\">Disabled</span>\n";
            str.Append("<br />" + _disabled);
        }
        // wallpaper, adult status
        if (this.ShowFeatured && this.ShowAdult)
        {
            string _adult = "<span class=\"" + this.GoodCssClass + "\">Non Adult</span>\n";
            if (vd.isAdult == 1)
                _adult = "<span class=\"" + this.BadCssClass + "\">Adult</span>\n";

            string _featured = "<span class=\"" + this.BadCssClass + "\">Normal</span>\n";
            if (vd.isFeatured == 1)
                _featured = "<span class=\"" + this.GoodCssClass + "\">Featured</span>\n";

            str.Append("<br />" + _adult + "&nbsp;|&nbsp;" + _featured);
        }
        else if (this.ShowFeatured)
        {
            string _featured = "<span class=\"" + this.BadCssClass + "\">Normal</span>\n";
            if (vd.isFeatured == 1)
                _featured = "<span class=\"" + this.GoodCssClass + "\">Featured</span>\n";
            str.Append("<br />" + _featured);
        }
        else if (this.ShowAdult)
        {
            string _adult = "<span class=\"" + this.GoodCssClass + "\">Non Adult</span>\n";
            if (vd.isAdult == 1)
                _adult = "<span class=\"" + this.BadCssClass + "\">Adult</span>\n";
            str.Append("<br />" + _adult);
        }
        // Comments
        if (this.ShowComments)
        {
            if (vd.isComments == 1) // enable comments
            {
                string _comments = "0";
                if (vd.Comments > 0)
                    _comments = string.Format("{0:#,###}", vd.Comments);

                str.Append("<br /><strong>" + _comments + "</strong> " + Resources.vsk.comments);
            }
        }
        // username 
        if (Config.isFeature_UserName() && this.ShowAuthor)
        {
            // if username enabled
            string _usr = vd.UserName;
            if (_usr.Length > 18)
                _usr = _usr.Substring(0, 18) + "..";
            string _usr_link = "<a class=\"" + this.NormalLinkCssClass + "\" href=\"" + this.AuthorUrl + "\"  title=\"" + vd.UserName + "\">" + _usr + "</a>";
            if (this.ShowTitle || this.ShowDate || this.ShowViews)
                str.Append("<br />");
            if (this.UserCaption != "")
                str.Append("<span class=\"" + this.AltLinkCssClass + "\">" + this.UserCaption + "</span> \n");
            str.Append(_usr_link);
        }
        if (this.ShowEditLink && this.EditLinkUrl != "")
        {
            // Show edit link
            this.EditLinkUrl = System.Text.RegularExpressions.Regex.Replace(this.EditLinkUrl, @"\[ID\]", vd.VideoID.ToString());
            str.Append("<br /><div class=\"item\"><a class=\"" + this.BadCssClass + "\" href=\"" + this.EditLinkUrl + "\">Edit</a></div>");

        }

        return str.ToString();
    }
}