﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;  
public partial class Search : System.Web.UI.Page
{
    private UtilityBLL _utility = new UtilityBLL();
    protected string NavigationClass = "chnl_left";
    protected string BodyClass = "chnl_right";

    protected void Page_Load(object sender, EventArgs e)
    {
        if (Site_Settings.NavigationSection == 1)
        {
            // right side navigation
            NavigationClass = "chnl_right_nav";
            BodyClass = "chnl_left_mn";
        }
        if (!Page.IsPostBack)
        {

            if (Request.Params["query"] != null)
            {
                Set_Filter_Urls();

                string search_term = UtilityBLL.CleanSearchTerm(Request.Params["query"].ToString()).Trim();
                search_term = UtilityBLL.ReplaceHyphinWithSpace(search_term);
                //*********************************************
                // User Search Tracking Script
                //********************************************
                // User search term storing and tracking
                // Good for generating wide range of tags based on user searches.
                // Help to improve, present your website data to search engines.
                // Search Record Tracking, if user search term less than 25 characters
                if (Site_Settings.StoreSearches)
                {
                    if (search_term.Length > 3 && search_term.Length < 25)
                    {
                        // validate user friendly searches
                        if (DictionaryBLL.Validate_Search_Word(search_term.Trim()))
                        {
                            // If search term already exist then stop adding dubplicate tag
                            if (!TagsBLL.Check_Tag(search_term.Trim()) && !search_term.Trim().Contains("@"))
                            {
                                int type = 5; // generalize tag
                                int tag_type = 1; // search based generated tag
                                int status = 1; // enable tag directly
                                int records = 1; // show one record in start by selected tag
                                TagsBLL.Add(Request.Params["query"].ToString().Trim(), type, records, tag_type, status, search_term.Trim());
                            }
                        }
                    }
                }
                //*************************************************
                // Close User Search Tracking
                //*************************************************
                int DateFilter = 0;
                if (Request.Params["filter"] != null)
                {
                    switch (Request.Params["filter"].ToString())
                    {
                        case "today":
                            DateFilter = 1;
                            break;
                        case "week":
                            DateFilter = 2;
                            break;
                        case "month":
                            DateFilter = 3;
                            break;
                    }
                }

                string order = "views desc, liked desc, added_date desc";
                if (Request.Params["sort"] != null)
                {
                    switch (Request.Params["sort"].ToString())
                    {
                        case "upload_date":
                            order = "added_date desc, liked desc, views desc";
                            break;
                        case "view_count":
                            order = "views desc, liked desc, added_date desc";
                            break;
                        case "rating":
                            order = "liked desc, views desc, added_date desc";
                            break;
                    }
                }
              
                string term = Server.UrlEncode(search_term);
                string heading = UtilityBLL.UppercaseFirst(search_term);

                sresult.InnerHtml = "Search results for \"" + heading + "\"";
                if (Request.Params["content"] != null)
                {
                    switch (Request.Params["content"].ToString())
                    {
                        case "videos":
                            if (Config.isVideos())
                            {
                                // video searches
                                vd_sm1.HeadingTitle = Resources.vsk.search_video_heading.Replace("[term]", heading);
                                vd_sm1.Term = term;
                                vd_sm1.SearchType = 3; // broad search
                                vd_sm1.Order = order.Replace("added_date", "date_added");
                                vd_sm1.isCache = false; // no cache for search
                                vd_sm1.Records = 36;
                                vd_sm1.See_All_Url = "videos/search.aspx?query=" + term;
                                vd_sm1.See_All_Url_Tooltip = Resources.vsk.search_video_all.Replace("[term]", term); // "Browse all videos related to term " + term;
                                vd_sm1.See_All_Text = Resources.vsk.seeall;
                                vd_sm1.AddedFilter = DateFilter;
                               
                            }
                            else
                            {
                                v_sect.Visible = false;
                            }
                            break;
                    }
                }
                else
                {
                    // video searches
                    if (Config.isVideos())
                    {
                        vd_sm1.HeadingTitle = "Videos related with search term \"" + term + "\"";
                        vd_sm1.Term = term;
                        vd_sm1.SearchType = 3; // broad search
                        vd_sm1.Order = order.Replace("added_date", "date_added");
                        vd_sm1.isCache = false; // no cache for search
                        vd_sm1.Records = 12;
                        vd_sm1.See_All_Url = "videos/search.aspx?query=" + term;
                        vd_sm1.See_All_Url_Tooltip = Resources.vsk.search_video_all.Replace("[term]", term); // "Browse all videos related to term " + term;
                        vd_sm1.See_All_Text = Resources.vsk.seeall;
                        vd_sm1.AddedFilter = DateFilter;
                    }
                    else
                    {
                        v_sect.Visible = false;
                    }
                }
                //Page.Title = heading + " Wallpapers, Pictures and Galleries";

                // set meta information
                System.Web.UI.HtmlControls.HtmlHead head = (System.Web.UI.HtmlControls.HtmlHead)Page.Header;
                string meta_title = sresult.InnerHtml; // Resources.vsk.meta_search_title.Replace("[term]", heading); //heading + " Videos, Audio Files, Wallpapers, Pictures and Galleries";
                string meta_description = Resources.vsk.meta_search_description.Replace("[term]", heading.ToLower());
                MetaTagsBLL.META_StaticPage(this.Page, head, meta_title, meta_description, UrlConfig.Return_Website_Logo_Url(), Config.GetUrl("search.aspx"));
            }
        }
    }

    private void Set_Filter_Urls()
    {
        string current_url = Config.GetUrl("Search.aspx?query=" + Request.Params["query"]);
        string sort_params = "";
        string filter_params = "";
        string content_params = "";

        if (Request.Params["sort"] != null)
        {
            filter_params = "&sort=" + Request.Params["sort"].ToString();
            content_params = "&sort=" + Request.Params["sort"].ToString();
        }
        if (Request.Params["filter"] != null)
        {
            sort_params = "&filter=" + Request.Params["filter"].ToString();
            content_params = "&filter=" + Request.Params["filter"].ToString();
        }
        if (Request.Params["content"] != null)
        {
            sort_params = "&content=" + Request.Params["content"].ToString();
            filter_params = "&content=" + Request.Params["content"].ToString();
        }
        // Order By Links
        oud.HRef = current_url + "&sort=upload_date" + sort_params;
        ovc.HRef = current_url + "&sort=view_count" + sort_params;
        or.HRef = current_url + "&sort=rating" + sort_params;

        // Filter By Links
        fut.HRef = current_url + "&filter=today" + filter_params;
        futw.HRef = current_url + "&filter=week" + filter_params;
        futm.HRef = current_url + "&filter=month" + filter_params;

        // Content Options
        vd.HRef = current_url + "&content=videos" + content_params;
        aud.HRef = current_url + "&content=audio" + content_params;
        wall.HRef = current_url + "&content=walls" + content_params;
      
        gal.HRef = current_url + "&content=galleries" + content_params;

    }
}