﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Text;

public partial class videos_archive_MostFavorited : System.Web.UI.Page
{
    protected string NavigationClass = "";
    protected string BodyClass = "";
    protected string BodyRight = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        // process website layout
        Process_Layout();

        if (!Page.IsPostBack)
        {
            if (Request.Params["y"] != null && Request.Params["m"] != null)
            {
                lst1.isListStatus = true;
                lst1.isListNav = true;
                lst1.Term = "";
                lst1.SearchType = 0;

                lst1.Month = Convert.ToInt32(Request.Params["m"]);
                lst1.Year = Convert.ToInt32(Request.Params["y"]);
                string monthname = UtilityBLL.ReturnMonthName(lst1.Month);

                lst1.PageTitle = Resources.vsk.videos_archive_fav_title.Replace("[date]", monthname + " " + lst1.Year);
                lst1.PageDescription = Resources.vsk.videos_archive_fav_desc.Replace("[date]", monthname + " " + lst1.Year);
                lst1.NoRecordFoundText = Resources.vsk.videos_archive_notfound.Replace("[date]", monthname + " " + lst1.Year); 
                lst1.isFeatured = 2; // load both featured and normal videos
                lst1.isAudio = 0; // load only videos
                lst1.isPrivate = 0; // load only public videos
                lst1.Order = "v.favorites desc,v.date_added desc, v.liked desc, v.views desc";
                lst1.isCache = true;
                lst1.PageSize = Site_Settings.Video_Page_Size;
                lst1.TabIndex = 2; // Most Commented
                // pagination urls
                lst1.DefaultUrl = "videos/archive/" + lst1.Year + "/" + lst1.Month + "/mostfavorited.aspx";
                lst1.Pagination_Url = "videos/archive/" + lst1.Year + "/" + lst1.Month + "/[p]/mostfavorited.aspx";
                // top navigation urls
                lst1.Recent_Url = "videos/archive/" + lst1.Year + "/" + lst1.Month + "/";
                lst1.MostViewed_Url = "videos/archive/" + lst1.Year + "/" + lst1.Month + "/mostviewed.aspx";
                lst1.MostFavorited_Url = "videos/archive/" + lst1.Year + "/" + lst1.Month + "/mostfavorited.aspx";
                lst1.Toprated_Url = "videos/archive/" + lst1.Year + "/" + lst1.Month + "/toprated.aspx";
                lst1.MostCommented_Url = "videos/archive/" + lst1.Year + "/" + lst1.Month + "/mostcommented.aspx";

                set_bread_links(monthname + " " + lst1.Year + " uploaded videos (most favorited).");

            }
            else
            {
                Response.Redirect(Config.GetUrl("videos/"));
            }

        }

    }


    private void set_bread_links(string title)
    {
        string _rooturl = Config.GetUrl();
        StringBuilder str = new StringBuilder();
        str.Append("<li><a href=\"" + _rooturl + "\">" + Resources.vsk.home + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/\">Videos</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/archive.aspx\">Archive</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li class=\"active\">" + title + "</li>\n");
        bread.InnerHtml = str.ToString();
    }

    // Core script to handle website layout
    private void Process_Layout()
    {
        UGeneral ug = new UGeneral();
        int selected_layout_option = Site_Settings.NavigationSection;
        if (selected_layout_option == 2)
        {
            // three column layout
            navigation1.Visible = false; // advance navigation disable
            navigation_sm1.Visible = true; // first column simple navigation
            third_nav1.Visible = true; // third column navigation
        }
        else
        {
            // two column layout
            navigation1.Visible = true;
            navigation_sm1.Visible = false;
            third_nav1.Visible = false;
        }

        NavigationClass = ug.Return_Navigation_Class();
        BodyClass = ug.Return_Body_Class();
        BodyRight = ug.Return_RightNav_Class();

    }
}
